/*
 * CPU.m - this handles set up of the 65c02
 * written by Chris Osborn <osborn@athena.ecs.csus.edu>
 */


#import "CPU.h"
#import "apple.h"
#import "VideoView.h"
#import "Controller.h"
#import <cthreads.h>
#import <appkit/Application.h>
#import <strings.h>
#import <appkit/defaults.h>
#import <cthreads.h>


int Debugging;
condition_t debugStep;
condition_t debugStepped;
mutex_t debugLock;

@implementation CPU

- powerUp
{
  extern void videoUpdate ();


  A = X = Y = 0;
  N = V = B = D = I = Z = C = 0;
  Sp = 0xff;
  
  /* Set Pc to pointer at $FFFC: */
  Pc = READLOC(0xfffc) + READLOC(0xfffd) * 0x0100;

  MegaQuitDetect = 0;
  MegaLastKey    = 0;
  MegaRand       = 0;

  thecpu = DPSAddTimedEntry (.1, videoUpdate, NULL, 1);
  [videoScreen refresh];
  SysMem[0xc061] = SysMem[0xc062] = SysMem[0xc000] = 0;

  debugStep = condition_alloc ();
  debugStepped = condition_alloc ();
  debugLock = mutex_alloc ();
  Debugging = 0;
  
  return self;
}

- execute
{
  cthread_detach (cthread_fork ((cthread_fn_t) CPUExecute, NULL));

  return self;
}
  
- reset:sender
{
  int d = Debugging;

  
  Debugging = 1;

  mutex_lock (debugLock);
  CPUReset ();
  Debugging = d;
  condition_signal (debugStep);
  mutex_unlock (debugLock);

  return self;
}

@end
