/*
 * apple.h -- Globals' xdefs and equates for system calls for Apple ][ Emulator
 * (C) 1989 Ben Koning [556498717 408/738-1763 ben@apple.com]
 *
 * Modified by Chris Osborn <osborn@athena.ecs.csus.edu>
 */



/* Character which ends the emulation: */



/* XENIX/BSD - Compatible includes: */

#ifndef BUFSIZ
#include <stdio.h>
#endif

#ifndef isalpha
#include <ctype.h>
#endif

#ifndef CBREAK
#include <sgtty.h>
#endif

#ifndef TIOCGETP
#include <sys/ioctl.h>
#endif

#ifndef O_NDELAY
#include <fcntl.h>
#endif

#define BYTE unsigned char
#define ADDR int


/* 6502 Globals: */

#include "mem.h"
#include "6502.h"


/* Emulation Globals: */

extern BYTE SysMem[];
extern int AltZP;
extern int AuxRead;
extern int AuxWrite;
extern int LCRead;
extern int LCWrite;
extern int Bank2Enable;
extern int Store80;
extern int ShowPage;
extern int HiResOn;
extern int SlotCXRom;
extern int SlotC3Rom;
extern int GraphicsOn;
extern int MixedOn;
extern int Vid80On;
extern int AltChar;
extern int VideoModeChange;

extern int ReadState;
extern int WriteState;

extern int bankreadoffset[7][128];
extern int bankwriteoffset[7][128];
extern int bankselect[];

extern BYTE MegaRand;
extern BYTE MegaLastKey;
extern BYTE MegaQuitDetect;
extern int DebugSingle;
extern int DebugTrace;
extern ADDR DebugBreak;

extern int refdelay;
extern int refresh;

/* Video vars */
extern int doScroll;
extern int AppleKeyBit, OptionKeyBit;
extern int AppleKey, OptionKey, ShiftKey;

/* Prototypes */
extern void MegaShutDown();
extern void MegaStartUp();

extern void prodos();
extern void ProInit();
extern void ProChangeDisk (int drive, char *newdiskname);

extern void CPUShutDown();
extern void CPUReset();
extern void CPUExecute();

/* prototypes to make the compiler happy */
extern void c700_boot ();
extern void bell1 ();
extern void bell1_2 ();
extern void bell2 ();
extern void scroll ();
extern void scrollcx ();
extern void refreshdisplay ();
extern void totalrefresh ();
extern void nextscroll ();
extern void unixShare ();

/* video display functions */
extern void videoUpdate ();
extern void videoScroll40 ();
